Dim Contain_Mat%()

Sub DrawBox (form1 As Form, BoxHeight, BoxWidth, BoxTop, BoxLeft)

' Draw Box on Printer at Coordinates of TextBox on Form
printer.CurrentX = BoxLeft
printer.CurrentY = BoxTop
printer.Line Step(0, 0)-Step(BoxWidth, BoxHeight), , B
   

End Sub

Sub DrawBoxText (form1 As Form, BoxText$, BoxHeight, BoxWidth, BoxTop, BoxLeft, TxtHeight)
'form1.Print "H="; BoxHeight; "  W="; BoxWidth; "  T="; BoxTop; "  L="; BoxLeft; "Txt="; TxtHeight

' Initialize counters, Pointers
CurrentLine$ = ""                              ' Line Being Worked On
LastSpace = 0                                  ' Track last word seperator
CurrentLineStart = 1                           ' Start or present line
                                               ' marked off in TextBox.Text
CharPtr = 1                                    ' Character Position In
                                               ' Present Line
CharWidth = 100                                ' Default Character Width
LMARG = 0                                      ' Forced Left Margin
YHeight = 0


'This is a Loop To Step Through Characters in TextBox.Text To Be Printed
CHARLOOP:

' If at end of string,print last line and exit
If CurrentLineStart + CharPtr - 1 > Len(BoxText$) Then GoTo PRINTLASTLINE


' Add new character to current line
NewChar$ = Mid$(BoxText$, CurrentLineStart + CharPtr - 1, 1)

' Record Character Width
If NewChar$ <> "" And NewChar$ <> Chr$(13) Then CharWidth = printer.TextWidth(NewChar$)

' Log Latest Word-Separator (Space) Position
If NewChar$ = " " Then LastSpace = CharPtr

CurrentLine$ = LTrim$(CurrentLine$ + NewChar$)
If printer.TextWidth(CurrentLine$) + LMARG > BoxWidth - CharWidth Then GoTo PRINTLINE
CharPtr = CharPtr + 1
GoTo CHARLOOP

PRINTLINE:
' Locate Present Line On Printer and print it

printer.CurrentX = BoxLeft + LMARG
printer.CurrentY = BoxTop + YHeight

If NewChar$ <> " " Then
   CurrentLine$ = Mid$(BoxText$, CurrentLineStart, LastSpace)
   CurrentLine$ = LTrim$(CurrentLine$)
   printer.Print CurrentLine$
'   form1.Print CurrentLine$
   CurrentLineStart = CurrentLineStart + LastSpace
   LastSpace = 0
   CurrentLine$ = ""
   CharPtr = 1
  Else
   CurrentLine$ = LTrim$(CurrentLine$)
   printer.Print CurrentLine$
'   form1.Print CurrentLine$
   CurrentLineStart = CurrentLineStart + CharPtr
   LastSpace = 0
   CurrentLine$ = ""
   CharPtr = 1
  End If


' Test For Still Being Within Box Height Limit
YHeight = YHeight + TxtHeight
If YHeight > BoxHeight - TxtHeight GoTo EDrawTEXTBOX
GoTo CHARLOOP

' Routine to print out last line and exit
PRINTLASTLINE:
If CurrentLine$ = "" Then GoTo EDrawTEXTBOX
printer.CurrentX = BoxLeft + LMARG
printer.CurrentY = BoxTop + YHeight
printer.Print CurrentLine$
'form1.Print CurrentLine$

EDrawTEXTBOX:
End Sub

Sub FormCopy (form1 As Form)

NoControls% = form1.Count

form1.CMDialog1.PrinterDefault = True
form1.CMDialog1.Action = 5

'Determine/Save Present Enabled settings of all entities
ReDim Enabled_Mat%(NoControls%)
Call SaveEnabled(form1, Enabled_Mat%())

'Determine Container/Containee Relationships
ReDim Contain_Mat%(NoControls%)
Call GetContainers(form1, Contain_Mat%())


For i% = 0 To NoControls% - 1

'-----------------------------------------------------------------
' Set Printer Font Name = Control FontName if Supported
On Error GoTo ERRHANDLER
FontSet = False
For ip% = 0 To (printer.FontCount - 1)
If printer.Fonts(ip%) = form1(i%).FontName Then
   printer.FontName = printer.Fonts(ip%)
   ip% = printer.FontCount - 1
   FontSet = True
   End If
Next ip%
'-----------------------------------------------------------------
' Set Font Size attributes
On Error Resume Next
printer.FontSize = form1(i%).FontSize
printer.FontBold = form1(i%).FontBold
printer.FontUnderline = form1(i%).FontUnderline
printer.FontStrikethru = form1(i%).FontStrikethru
printer.FontItalic = form1(i%).FontItalic

'--------------------------------------------------------
' Determine Offset of TOP and LEFT properties for items
' which are contained within frames or other containers

If Contain_Mat%(i%) >= form1.Count Then
     OFFSET_TOP = 0
     OFFSET_LEFT = 0
   Else
     ContainerIndex = Contain_Mat%(i%)
     OFFSET_TOP = form1(ContainerIndex).Top
     OFFSET_LEFT = form1(ContainerIndex).Left
   End If

' Identify Control's Height, Width, Top, Left of Box
BoxHeight = form1(i%).Height
BoxWidth = form1(i%).Width
BoxTop = form1(i%).Top + OFFSET_TOP
BoxLeft = form1(i%).Left + OFFSET_LEFT
On Error GoTo 0


'--------------------------------------------------------
On Error Resume Next

If TypeOf form1(i%) Is TextBox Then


' Draw Box on Printer at Coordinates of TextBox on Form
Call DrawBox(form1, BoxHeight, BoxWidth, BoxTop, BoxLeft)
   
' Long Process To Add Text Starts here

' Skip If TextBox Doesn't Have any Text
SText$ = RTrim$(LTrim$(form1(i%).Text))
If SText$ = "" Then GoTo ETEXTBOX
CurrentYHeight = printer.TextHeight(form1(i%).Text)    ' Height of Lines printed
Call DrawBoxText(form1, SText$, BoxHeight, BoxWidth, BoxTop, BoxLeft, CurrentYHeight)

   
ETEXTBOX:
GoTo EControlLoop
End If

'-----------------------------------------------------------------

FRAME0:
If TypeOf form1(i%) Is Frame Then GoTo Frame1
If TypeOf form1(i%) Is SSFrame Then GoTo Frame1
GoTo CHECKBOX0

Frame1:
   ' draw 1st top segment
   printer.CurrentX = form1(i%).Left
   printer.CurrentY = form1(i%).Top
   printer.Line Step(0, 100)-Step(100, 0)
   
   ' draw caption
   printer.CurrentX = form1(i%).Left + 150
   printer.CurrentY = form1(i%).Top + 50
   printer.Print form1(i%).Caption
   
   ' draw 2nd top segment
   printer.CurrentX = form1(i%).Left + printer.TextWidth(form1(i%).Caption) + 200
   printer.CurrentY = form1(i%).Top + 100
   remaining = form1(i%).Width - 200 - printer.TextWidth(form1(i%).Caption)
   printer.Line Step(0, 0)-Step(remaining, 0)

   ' draw left side
   printer.CurrentX = form1(i%).Left
   printer.CurrentY = form1(i%).Top
   printer.Line Step(0, 100)-Step(0, form1(i%).Height - 100)

   ' draw right side
   printer.CurrentX = form1(i%).Left + form1(i%).Width
   printer.CurrentY = form1(i%).Top
   printer.Line Step(0, 100)-Step(0, form1(i%).Height - 100)
   
   ' draw bottom
   printer.CurrentX = form1(i%).Left
   printer.CurrentY = form1(i%).Top + form1(i%).Height
   printer.Line Step(0, 0)-Step(form1(i%).Width, 0)
   
GoTo EControlLoop
  

'-----------------------------------------------------------------
CHECKBOX0:
If TypeOf form1(i%) Is CheckBox Then GoTo CHECKBOX1
If TypeOf form1(i%) Is SSCheck Then GoTo CHECKBOX1
GoTo OPTIONBUTTON0

CHECKBOX1:

' Draw CheckBox Outline
CheckHeight = form1(i%).Height
printer.CurrentY = form1(i%).Top + OFFSET_TOP + (.5 * CheckHeight) - 50
printer.CurrentX = form1(i%).Left + OFFSET_LEFT
printer.Line Step(0, 0)-Step(100, 100), , B

' Draw CheckMark if Checked
If form1(i%).Value = 1 Or form1(i%).Value = -1 Then
printer.CurrentY = form1(i%).Top + OFFSET_TOP + (.5 * CheckHeight) - 50
printer.CurrentX = form1(i%).Left + OFFSET_LEFT
printer.Line Step(0, 0)-Step(100, 100)
printer.CurrentY = form1(i%).Top + OFFSET_TOP + (.5 * CheckHeight) + 50
printer.CurrentX = form1(i%).Left + OFFSET_LEFT
printer.Line Step(0, 0)-Step(100, -100)
End If

' Draw Caption
CaptHeight = printer.TextHeight(form1(i%).Caption)
printer.CurrentY = form1(i%).Top + OFFSET_TOP + (.5 * CheckHeight) - (.5 * CaptHeight)
printer.CurrentX = form1(i%).Left + OFFSET_LEFT + 150
printer.Print form1(i%).Caption

GoTo EControlLoop

'-------------------------------------------------------------
OPTIONBUTTON0:
If TypeOf form1(i%) Is OptionButton Then GoTo OPTIONBUTTON1
If TypeOf form1(i%) Is SSOption Then GoTo OPTIONBUTTON1
GoTo LABEL0

OPTIONBUTTON1:

' Draw OptionButton Outline
CheckHeight = form1(i%).Height
printer.CurrentY = form1(i%).Top + OFFSET_TOP + (.5 * CheckHeight)
printer.CurrentX = form1(i%).Left + OFFSET_LEFT + 60
printer.Circle Step(0, 0), 60

' Draw Check-Dot if Selected
If form1(i%).Value = 1 Or form1(i%).Value = -1 Then
printer.CurrentY = form1(i%).Top + OFFSET_TOP + (.5 * CheckHeight)
printer.CurrentX = form1(i%).Left + OFFSET_LEFT + 60
OldFillStyle = printer.FillStyle
OldFillColor = printer.FillColor
printer.FillStyle = 0
printer.FillColor = QBColor(0)
printer.Circle Step(0, 0), 30
printer.FillStyle = OldFillStyle
printer.FillColor = OldFillColor
End If

' Draw Caption
CaptHeight = printer.TextHeight(form1(i%).Caption)
printer.CurrentY = form1(i%).Top + OFFSET_TOP + (.5 * CheckHeight) - (.5 * CaptHeight)
printer.CurrentX = form1(i%).Left + OFFSET_LEFT + 150
printer.Print form1(i%).Caption

GoTo EControlLoop

'-----------------------------------------------------------------
LABEL0:
If TypeOf form1(i%) Is Label Then GoTo LABEL1
If TypeOf form1(i%) Is SSPanel Then GoTo LABEL1
GoTo COMMANDBUTTON0:

LABEL1:

' Draw Box Outline if Enabled

If form1(i%).BorderStyle = 1 Then Call DrawBox(form1, BoxHeight, BoxWidth, BoxTop, BoxLeft)

' Call Process To Add Text

' Skip If TextBox Doesn't Have any Text
SText$ = RTrim$(LTrim$(form1(i%).Caption))
If SText$ = "" Then GoTo ELABEL
CurrentYHeight = printer.TextHeight(form1(i%).Caption)    ' Height of Lines printed
Call DrawBoxText(form1, SText$, BoxHeight, BoxWidth, BoxTop, BoxLeft, CurrentYHeight)

   
ELABEL:
  
GoTo EControlLoop

'-----------------------------------------------------------------
COMMANDBUTTON0:

If TypeOf form1(i%) Is CommandButton Then GoTo COMMANDBUTTON1
If TypeOf form1(i%) Is SSCommand Then GoTo COMMANDBUTTON1
GoTo GRID0

COMMANDBUTTON1:

' Draw Box on Printer at Coordinates of Command on Form
Call DrawBox(form1, BoxHeight, BoxWidth, BoxTop, BoxLeft)

'Locate Text in Center of Box & Print

YHeight = printer.TextHeight(form1(i%).Caption)    ' Height of Lines printed

printer.CurrentX = BoxLeft + .5 * BoxWidth - .5 * (printer.TextWidth(form1(i%).Caption))
printer.CurrentY = BoxTop + .5 * BoxHeight - .5 * (YHeight)
printer.Print form1(i%).Caption

GoTo EControlLoop

'-----------------------------------------------------------------

GRID0:
If TypeOf form1(i%) Is Grid Then GoTo GRID1
GoTo EControlLoop

GRID1:
  
nrows = form1(i%).Rows
ncols = form1(i%).Cols

row_start = form1(i%).Top + OFFSET_TOP
row_offset = 0
   
For ix% = 0 To nrows - 1
form1(i%).Row = ix%
col_start = form1(i%).Left + OFFSET_LEFT
col_offset = 0
   
For iy% = 0 To ncols - 1
form1(i%).Col = iy%
  
printer.CurrentX = col_start + col_offset
printer.CurrentY = row_start + row_offset
printer.Print form1(i%).Text

printer.CurrentX = col_start + col_offset
printer.CurrentY = row_start + row_offset
printer.Line Step(0, 0)-Step(form1(i%).ColWidth(iy%), form1(i%).RowHeight(ix%)), , B
   
col_offset = col_offset + form1(i%).ColWidth(iy%)
   
Next iy%

row_offset = row_offset + form1(i%).RowHeight(ix%)
   
Next ix%


EControlLoop:
On Error GoTo 0
Next i%


ETEST:
printer.EndDoc
GoTo ESUB

ERRHANDLER:
printer.FontName = "Courier"
Resume Next

ESUB:

'Restore Enabled settings of all entities
Call RestoreEnabled(form1, Enabled_Mat%())

End Sub

Sub GetContainers (form1 As Form, Contain_Mat%())

' This routine will build up a Matrix Contain _Mat.
' The Matrix will have an entry for each control
' indicating if the control is within a container
' other than the Form.
'
' If the control is in a container, the Contain_Mat entry
' indicates the control number of the container.
' If the control is not in any container other than the
' form, the Contain_mat entry is set to NoControls%
' (an invalid setting)
'

' Initially set all entries of Contain_Mat%() to form.count
For iv% = 0 To form1.Count - 1
Contain_Mat%(iv%) = form1.Count
Next iv%

' Loop through every control on the Form
For iv% = 0 To form1.Count - 1

' Set all enabled flags to True
Call SetEnabled(form1, x)

' Set Enabled Flag of Control Under test to False
On Error Resume Next
form1(iv%).Enabled = False
On Error GoTo 0

' Test all (other) controls on Form and see which are turned False
For iy% = 0 To form1.Count - 1
If iy% = iv% Then GoTo NEXTIY

On Error Resume Next
If form1(iy%).Enabled = False Then
   Contain_Mat%(iy%) = iv%
   End If
On Error GoTo 0

NEXTIY:
Next iy%
Next iv%

End Sub

Sub RestoreEnabled (form1 As Form, Enabled_Mat%())

' This routine restores the Enabled Property of all the
' controls on a Form to the value (previosuly) stored in
' the array Enabled_Mat%()
'

On Error Resume Next
For ixp% = 0 To form1.Count - 1
form1(ixp%).Enabled = Enabled_Mat%(ixp%)
Next ixp%
On Error GoTo 0

End Sub

Sub SaveEnabled (form1 As Form, Enabled_Mat%())
' This routine Stores in a matrix Enabled_Mat
' the status of the Enabled Property for each control
' on the form.  The value of Enabled for each control
'is set to True
'
' Form Print Will Modify the Enabled Property. At the
' end of FormPrint the contents of Enabled_Mat will be used
' to restore the initial Enabled property settings for
' each control.

On Error Resume Next
For ixp% = 0 To form1.Count - 1
Enabled_Mat%(ixp%) = form1(ixp%).Enabled
form1(ixp%).Enabled = True
Next ixp%
On Error GoTo 0

End Sub

Sub SetEnabled (form1 As Form, x)
' This routine sets the Enabled property of all controls
' on a Form to True

On Error Resume Next
For ixp% = 0 To form1.Count - 1
form1(ixp%).Enabled = True
Next ixp%
On Error GoTo 0

End Sub

